#include <ntddk.H>
#include <stdio.h>

#include "CODEHOOK.h"

// ũ  Լ ڵ ּҸ Write ּҷ 
PVOID GetMappedMemoryAddress( ULONG NumberOfBytes, PHYSICAL_ADDRESS PhysicalAddress )
{
	PHYSICAL_ADDRESS   translatedAddress;
	PVOID              deviceBase = NULL;
	{
		translatedAddress.u.HighPart = 0;
		translatedAddress.u.LowPart = PhysicalAddress.u.LowPart;
		deviceBase = MmMapIoSpace (translatedAddress, NumberOfBytes, FALSE );
	}
	return deviceBase;
}

INT HookService(void)
{
	unsigned char *d, *dwTemp;
	int i, j, dwCount;
	PHYSICAL_ADDRESS dwAddress;

	_asm
	{
		mov  ebx , cr0  ; get Cr0 regiter 
		push ebx   ; save it			

	   	and ebx , ~0x10000  ; clear WP bit
	   	mov cr0 , ebx  ; efectivly disable write protection 
	 } 

	d = (unsigned char *)KeInsertQueueDpc;
	dwAddress = MmGetPhysicalAddress(d);
	dwCount = 0x1000;
	dwTemp = GetMappedMemoryAddress( dwCount, dwAddress );
	if( !dwTemp )
	{
		HookKeInsertQueueDpc(CODE_ID_KEINSERTQUEUEDPC, d, d);
	}
	else
	{
		HookKeInsertQueueDpc(CODE_ID_KEINSERTQUEUEDPC, dwTemp, d);
		MmUnmapIoSpace( dwTemp, dwCount );
	}

  	_asm
  	{ 
  		pop ebx          ;restore it
   		mov cr0 , ebx    ; enable previous CPU state. 
   	} 
	return TRUE;
}

INT UnHookService(void)
{
	UnHookKeInsertQueueDpc(CODE_ID_KEINSERTQUEUEDPC);
	return TRUE;
}

NTSTATUS CODEHOOKCreateClose( PDEVICE_OBJECT DeviceObject, PIRP Irp )
{
	Irp->IoStatus.Status = STATUS_SUCCESS;
	Irp->IoStatus.Information = 0;
	IoCompleteRequest( Irp, IO_NO_INCREMENT );
	return STATUS_SUCCESS;
}

void CODEHOOKUnload(PDRIVER_OBJECT DriverObject)
{
	UnHookService();
	IoDeleteDevice( DriverObject->DeviceObject );
}

NTSTATUS DriverEntry(PDRIVER_OBJECT DriverObject, PUNICODE_STRING RegistryPath)
{
    PDEVICE_OBJECT  functionalDeviceObject;
	UNICODE_STRING UniDeviceName;
    NTSTATUS code = STATUS_SUCCESS;     

    DriverObject->DriverUnload = CODEHOOKUnload;
	DriverObject->MajorFunction[IRP_MJ_CREATE] = CODEHOOKCreateClose;
	DriverObject->MajorFunction[IRP_MJ_CLOSE] = CODEHOOKCreateClose;

	RtlInitUnicodeString( &UniDeviceName, L"\\Device\\CODEHOOK" );

    IoCreateDevice(DriverObject,0, &UniDeviceName,FILE_DEVICE_UNKNOWN,
		0,FALSE,&functionalDeviceObject);

    functionalDeviceObject->Flags &= ~DO_DEVICE_INITIALIZING;
   
	HookService();

    return(STATUS_SUCCESS); 
		
}














